﻿using ForumContracts.BindingModels;
using ForumContracts.SearchModels;
using ForumDatabaseImplement;
using Microsoft.Extensions.DependencyInjection;
using ForumMongoDataBase;
using MongoDB.Driver;
using System;
using System.Data;
using System.Reflection.Metadata.Ecma335;

ForumMongoDataBase.Implements.AnswerStorage answerStorageMongo = new();
ForumDatabaseImplement.ForumDataBase forumContext = new();
ForumDatabaseImplement.Implements.AnswerStorage answerStoragePost = new();

Console.WriteLine("start Answer");
foreach (var answer in forumContext.Answers.ToList())
{
	if (answerStorageMongo.GetElement(new AnswerSearchModel { AnswerDes = answer.AnswerDes, ResponseDate = answer.ResponseDate, Id=answer.Id,QuestionId=answer.QuestionId, UserId = answer.UserId }) == null)
	{
		answerStorageMongo.Insert(new AnswerBindingModel { AnswerDes = answer.AnswerDes, ResponseDate = answer.ResponseDate, Id = answer.Id, QuestionId = answer.QuestionId, UserId = answer.UserId });
	}
}
Console.WriteLine("finish Answer");
ForumMongoDataBase.Implements.QuestionStorage questionStorageMongo = new();
Console.WriteLine("start Question");
foreach (var question in forumContext.Questions.ToList())
{
	if (questionStorageMongo.GetElement(new QuestionSearchModel { QuestionDes = question.QuestionDes, CreateDate=question.CreateDate, UserId=question.UserId, Id=question.Id, CategoryId=question.CategoryId }) == null)
	{
		questionStorageMongo.Insert(new QuestionBindingModel { QuestionDes = question.QuestionDes, CreateDate = question.CreateDate, UserId = question.UserId, Id = question.Id, CategoryId = question.CategoryId });
	}
}
Console.WriteLine("finish Question");
ForumMongoDataBase.Implements.CategoryStorage categoryStorageMongo = new();
Console.WriteLine("start Category");
foreach (var category in forumContext.Categories.ToList())
{
	if (categoryStorageMongo.GetElement(new CategorySearchModel { Name=category.Name, Description=category.Description,Id=category.Id }) == null)
	{
		categoryStorageMongo.Insert(new CategoryBindingModel { Name = category.Name, Description = category.Description, Id = category.Id });
	}
}
Console.WriteLine("finish Category");
ForumMongoDataBase.Implements.UserStorage userStorageMongo = new();
Console.WriteLine("start User");
foreach (var user in forumContext.Users.ToList())
{
	if (userStorageMongo.GetElement(new UserSearchModel { Nickname=user.Nickname, ActivityDate=user.ActivityDate, Email=user.Email, Password=user.Password,Id=user.Id, RegistrationDate=user.RegistrationDate }) == null)
	{
		userStorageMongo.Insert(new UserBindingModel { Nickname = user.Nickname, ActivityDate = user.ActivityDate, Email = user.Email, Password = user.Password, Id = user.Id, RegistrationDate = user.RegistrationDate });
	}
}
Console.WriteLine("finish User");